unit chcolor;
{-------------------------------------------------------------------------------
  Modulissa on aliohjelmia vrien vaihtamiseksi

  Tekij:         Vesa Lappalainen
  Aika:           22.7.1996
  Delphi-versio:  1.0 & 2.0
  Muutokset:
  Kytt:
    Komponentin vri vaihdetaan kutsulla
     SetColor(comp,color)
    samalla komponentin vri merkitn talletettavaksi ini-tiedostoon. 
-------------------------------------------------------------------------------}

interface

uses   MPlayer,ExtCtrls,Classes,
       Graphics,Dialogs,Forms,DBCtrls,StdCtrls,
       SysUtils,IniFiles;

function GetColor(comp:TObject):TColor;
procedure SetColor(comp:TObject; color:TColor);
procedure ChangeColor(comp:TObject;ColorDlg:TColorDialog);
procedure ReadColor(Ini:TIniFile;section:string;entry:string;comp:TObject);
procedure WriteColor(Ini:TIniFile;section:string;entry:string;comp:TObject);
procedure ReadColors(form:TForm;name:string;section:string);
procedure SaveColors(form:TForm;name:string;section:string);

implementation


{------------------------------------------------------------------------------}
function GetColor(comp:TObject):TColor;
begin
  Result := -2;
  if ( comp is TForm   ) then Result := (comp as TForm  ).color;
  if ( comp is TDBEdit ) then Result := (comp as TDBEdit).color;
  if ( comp is TLabel  ) then Result := (comp as TLabel ).color;
  if ( comp is TPanel  ) then Result := (comp as TPanel ).color;
end;

{------------------------------------------------------------------------------}
procedure SetColor(comp:TObject; color:TColor);
begin
  if ( comp is TForm   ) then (comp as TForm  ).Color := color;
  if ( comp is TDBEdit ) then (comp as TDBEdit).Color := color;
  if ( comp is TLabel  ) then (comp as TLabel ).Color := color;
  if ( comp is TPanel  ) then (comp as TPanel ).Color := color;
end;

{------------------------------------------------------------------------------}
procedure ChangeColor(comp:TObject;ColorDlg:TColorDialog);
var color:TColor;
begin
  color := GetColor(comp);
  if ( color = -2 ) then exit;
  ColorDlg.Color := color;
  if ( not ColorDlg.Execute ) then exit;
  color := ColorDlg.Color;
  SetColor(comp,color);
end;

{------------------------------------------------------------------------------}
procedure ReadColor(Ini:TIniFile;section:string;entry:string;comp:TObject);
var color:TColor;
begin
  if ( comp = NIL ) then exit;
  with Ini do begin
    color := ReadInteger(section,entry,-2);
    if ( color <> -2 ) then SetColor(comp,color);
  end;
end;

{------------------------------------------------------------------------------}
procedure WriteColor(Ini:TIniFile;section:string;entry:string;comp:TObject);
var color:TColor;
begin
  with Ini do begin
    color := GetColor(comp);
    if ( color = -2 ) then exit;
    WriteString(section,entry,format('$%x',[color]));
  end;
end;

{------------------------------------------------------------------------------}
procedure ReadColors(form:TForm;name:string;section:string);
var
    i:integer;
    s:string;
    sec:TStringList;
    comp : TComponent;
    Ini:TIniFile;
begin
  Ini := TIniFile.Create(name);
  ReadColor(Ini,section,'form',form);
  sec := TStringList.Create;
  Ini.ReadSection(section,sec);
  for i:=0 to sec.count-1 do begin
    s := sec.Strings[i];
    comp := form.FindComponent(s);
    ReadColor(Ini,section,s,comp);
  end;
  sec.free;
end;

{------------------------------------------------------------------------------}
procedure SaveColors(form:TForm;name:string;section:string);
var color:TColor;
    i:integer;
    s:string;
    Ini:TIniFile;
begin
  Ini := TIniFile.Create(name);
  WriteColor(Ini,section,'form',form);
  for i:=0 to form.ComponentCount-1 do begin
    s := form.Components[i].Name;
    if ( form.Components[i].tag < 5000 ) then continue;
    WriteColor(Ini,section,s,form.Components[i]);
  end;
  Ini.free;
end;



end.
